Option Strict On
Option Explicit On

Imports Microsoft.Win32.SafeHandles
Imports System.Runtime.InteropServices

Namespace WinUsbDemo

    ''' <summary>
    ''' API declarations relating to file I/O.
    ''' </summary>

    Friend NotInheritable Class FileIO

        Friend Const FILE_ATTRIBUTE_NORMAL As Int16 = &H80
        Friend Const FILE_FLAG_OVERLAPPED As Int32 = &H40000000
        Friend Const FILE_SHARE_READ As Int16 = &H1S
        Friend Const FILE_SHARE_WRITE As Int16 = &H2S
        Friend Const GENERIC_READ As Long = &H80000000
        Friend Const GENERIC_WRITE As UInt32 = &H40000000
        Friend Const INVALID_HANDLE_VALUE As Int32 = -1
        Friend Const OPEN_EXISTING As Int16 = 3

        <StructLayout(LayoutKind.Sequential)> _
        Friend Structure SECURITY_ATTRIBUTES
            Friend nLength As Int32
            Friend lpSecurityDescriptor As Int32
            Friend bInheritHandle As Int32
        End Structure

        <DllImport("kernel32.dll", SetLastError:=True)> Shared Function CloseHandle _
            (ByVal hObject As SafeFileHandle) _
            As Boolean
        End Function

        <DllImport("kernel32.dll", CharSet:=CharSet.Auto, SetLastError:=True)> Shared Function CreateFile _
            (ByVal lpFileName As String, _
            ByVal dwDesiredAccess As Int32, _
            ByVal dwShareMode As Int32, _
            ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, _
            ByVal dwCreationDisposition As Int32, _
            ByVal dwFlagsAndAttributes As Int32, _
            ByVal hTemplateFile As Int32) _
            As SafeFileHandle
        End Function

    End Class

End Namespace
